import { IEffectsAction } from 'redux-effects-promise';
import { AnyT } from '../definitions.interface';
import { IApplicationSettings } from '../settings';
import { IRoutesConfiguration } from '../configurations-definitions.interface';
import { IApplicationStorage } from '../storage/storage.interface';
import { BaseEffects } from '../store/effects/base.effects';
import { IUniversalApplicationStoreEntity } from '../entities-definitions.interface';
import { IApplicationTransportPayloadAnalyzer, IApplicationTransportFactory } from '../transport/transport.interface';
export declare class UniversalApplicationEffects<TApi> extends BaseEffects<TApi> {
    private static logger;
    protected routes: IRoutesConfiguration;
    protected settings: IApplicationSettings;
    protected notVersionedPersistentStorage: IApplicationStorage;
    protected notVersionedSessionStorage: IApplicationStorage;
    protected transportPayloadAnalyzer: IApplicationTransportPayloadAnalyzer;
    protected fetchJsonTransportFactory: IApplicationTransportFactory;
    /**
     * @stable - 25.04.2018
     * @returns {Promise<IEffectsAction[]> | IEffectsAction[]}
     */
    $onInit(): Promise<IEffectsAction[]>;
    /**
     * @stable [02.09.2018]
     * @returns {IEffectsAction}
     */
    $onAfterInit(_: IEffectsAction, state: IUniversalApplicationStoreEntity): Promise<IEffectsAction[]>;
    /**
     * @stable - 25.04.2018
     * @returns {Promise<AnyT> | IEffectsAction[] | IEffectsAction}
     */
    $onPrepare(): Promise<AnyT> | IEffectsAction[] | IEffectsAction;
    /**
     * @stable - 25.04.2018
     * @returns {Promise<AnyT> | IEffectsAction[] | IEffectsAction}
     */
    $onPrepareDone(action: IEffectsAction, state: IUniversalApplicationStoreEntity): Promise<AnyT> | IEffectsAction[] | IEffectsAction;
    /**
     * @stable - 25.04.2018
     * @param {IEffectsAction} action
     * @returns {IEffectsAction}
     */
    $onPrepareError(action: IEffectsAction): IEffectsAction;
    /**
     * @stable - 25.04.2018
     * @returns {IEffectsAction[]}
     */
    $onAfterLogin(): IEffectsAction[];
    /**
     * @stable - 25.04.2018
     * @returns {IEffectsAction[]}
     */
    $onLogout(): IEffectsAction[];
    /**
     * @stable - 25.04.2018
     * @returns {IEffectsAction[] | Promise<IEffectsAction[]>}
     */
    $onAfterLogout(): IEffectsAction[] | Promise<IEffectsAction[]>;
    /**
     * @stable - 25.04.2018
     * @param {IEffectsAction} action
     * @param {IUniversalApplicationStoreEntity} state
     */
    $onAuthorized(action: IEffectsAction, state: IUniversalApplicationStoreEntity): Promise<void>;
    /**
     * @stable - 25.04.2018
     */
    $onUnauthorized(): Promise<void>;
}
