import { AnyT } from '../definitions.interface';
import { IChannelsEntity } from '../entities-definitions.interface';
import { PayloadWrapper } from './protocol';
/**
 * @stable [21.05.2018]
 */
export interface IChannelClient {
    on(event: string, callback: (...args: AnyT[]) => void): void;
    emit(event: string, ...args: AnyT[]): void;
    close(): void;
}
/**
 * @stable [21.05.2018]
 */
export interface IChannel<TConfig = AnyT> {
    connect(ip: string, config?: TConfig): void;
    disconnect(ip: any): void;
    onConnect(ip: string, client: IChannelClient): void;
    onDisconnect(ip: string, client: IChannelClient): void;
    onMessage(ip: string, messageName?: string, payload?: string): void;
    emitEvent(ip: string, event: string, ...args: AnyT[]): void;
    emitChannelEvent(ip: string, ...args: AnyT[]): void;
    emitRequestPayload(ip: string, requestPayload: PayloadWrapper): void;
}
/**
 * @stable [20.05.2018]
 */
export declare const INITIAL_APPLICATION_CHANNEL_STATE: IChannelsEntity;
export declare const CHANNEL_CONNECT_EVENT = "connect";
export declare const CHANNEL_DISCONNECT_EVENT = "disconnect";
export declare const CHANNEL_SEND_EVENT = "send";
export declare const CHANNEL_CONNECT_MESSAGE = "connect";
export declare const CHANNEL_DISCONNECT_MESSAGE = "disconnect";
export declare const $CHANNEL_MESSAGE_ACTION_TYPE: string;
export declare const $CHANNEL_CONNECTED_ACTION_TYPE: string;
export declare const $CHANNEL_DISCONNECTED_ACTION_TYPE: string;
