import 'signalr';
import { ILogger } from 'ts-smart-logger';
import { BaseChannel } from '../base-channel.service';
import { ISignalRChannelConfig } from './signalr-channel.interface';
export declare class SignalRChannel extends BaseChannel<ISignalRChannelConfig> {
    protected static logger: ILogger;
    private signalRScriptTask;
    private signalRInitTasks;
    /**
     * @stable [12.12.2018]
     */
    constructor();
    /**
     * @stable [21.05.2018]
     * @param {string} ip
     * @param {ISignalRChannelConfig} config
     */
    connect(ip: string, config?: ISignalRChannelConfig): void;
    /**
     * @stable [11.12.2018]
     * @param {string} ip
     */
    disconnect(ip: string): void;
    /**
     * @stable [12.12.2018]
     * @param {string} ip
     * @param {string} hubUrl
     * @param {ISignalRChannelConfig} config
     */
    private onSignalRInitialize;
    /**
     * @stable [11.12.2018]
     * @param {string} ip
     */
    private cancelInitTask;
}
