"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_native_router_flux_1 = require("react-native-router-flux");
var util_1 = require("../../util");
var universal_application_container_1 = require("./universal-application.container");
var rn_message_component_1 = require("../message/rn-message.component");
var RnApplicationContainer = /** @class */ (function (_super) {
    __extends(RnApplicationContainer, _super);
    function RnApplicationContainer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RnApplicationContainer.prototype.render = function () {
        var props = this.props;
        if (this.isMessageVisible()) {
            return (React.createElement(rn_message_component_1.RnMessage, { error: props.error, progress: props.progress, errorMessage: this.getErrorMessage(), emptyMessage: this.settings.messages.appNotReadyMessage }));
        }
        return (React.createElement(react_native_router_flux_1.Router, null,
            React.createElement(react_native_router_flux_1.Lightbox, { key: 'lightbox' },
                React.createElement(react_native_router_flux_1.Stack, { hideNavBar: props.hideNavBar, key: 'root' }, this.getRoutes(function (routeConfiguration) { return !routeConfiguration.modal; })),
                this.getRoutes(function (routeConfiguration) { return routeConfiguration.modal === true; }))));
    };
    RnApplicationContainer.prototype.buildRoute = function (ctor, connectorConfiguration, cfg) {
        var _this = this;
        return (React.createElement(react_native_router_flux_1.Scene, { component: ctor, key: cfg.key || cfg.path, path: cfg.path, title: cfg.title, initial: util_1.isFn(cfg.initial)
                ? cfg.initial(function () { return _this.auth.isAuthorized(); }, this.appStore)
                : !!cfg.initial, onEnter: cfg.onEnter }));
    };
    RnApplicationContainer.defaultProps = {
        hideNavBar: true,
    };
    return RnApplicationContainer;
}(universal_application_container_1.UniversalApplicationContainer));
exports.RnApplicationContainer = RnApplicationContainer;
//# sourceMappingURL=rn-application.container.js.map