"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../../util");
var env_1 = require("../../env");
var di_1 = require("../../di");
var application_interface_1 = require("../application/application.interface");
var vue_index_1 = require("../base/vue-index");
var vue_index_2 = require("../connector/vue-index");
var VueApplicationContainer = /** @class */ (function (_super) {
    __extends(VueApplicationContainer, _super);
    function VueApplicationContainer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VueApplicationContainer_1 = VueApplicationContainer;
    /**
     * @stable [21.10.2018]
     * @param {CreateElement} factory
     * @returns {VueNodeT}
     */
    VueApplicationContainer.prototype.render = function (factory) {
        return factory(this.getContainer());
    };
    /**
     * @stable [23.10.2018]
     * @returns {string}
     */
    VueApplicationContainer.prototype.getContainer = function () {
        var appPath = env_1.ENV.appPath();
        var routePatternResult = util_1.findUrlPattern(appPath, this.routes);
        if (routePatternResult.route) {
            VueApplicationContainer_1.logger.debug("[$VueApplicationContainer][getContainer] Router is recognized. Route result: " + JSON.stringify(routePatternResult) + ", pathname: \"" + appPath + "\"");
        }
        else {
            VueApplicationContainer_1.logger.warn("[$VueApplicationContainer][getContainer] Router is not recognized. Route result: \"" + appPath + "\"");
        }
        return this.routes[routePatternResult.route] || this.routes['/not_found'];
    };
    var VueApplicationContainer_1;
    VueApplicationContainer.logger = ts_smart_logger_1.LoggerFactory.makeLogger('VueApplicationContainer');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Routes),
        __metadata("design:type", Object)
    ], VueApplicationContainer.prototype, "routes", void 0);
    VueApplicationContainer = VueApplicationContainer_1 = __decorate([
        vue_property_decorator_1.Component(vue_index_2.vueConnectorOptionsFactory({
            section$: application_interface_1.APPLICATION_SECTION,
            customComputed$: [
                function (state) { return ({ application: state.application }); } // TODO move to common
            ],
            forceUpdateOnChangeData$: function (state) { return state.application.path; },
        }))
    ], VueApplicationContainer);
    return VueApplicationContainer;
}(vue_index_1.VueBaseContainer));
exports.VueApplicationContainer = VueApplicationContainer;
//# sourceMappingURL=vue-application.container.js.map