"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var util_1 = require("../../util");
var configurations_definitions_interface_1 = require("../../configurations-definitions.interface");
var universal_connector_mapper_1 = require("./universal-connector.mapper");
exports.rootMapper = function (state) { return ({
    root: __assign({}, state.root),
}); };
exports.layoutMapper = function (state) { return ({
    layout: __assign({}, state.layout),
}); };
/**
 * @stable [18.09.2018]
 * @param {IStackWrapperEntity} state
 * @returns {IStackWrapperEntity}
 */
exports.stackMapper = function (state) { return ({
    stack: __assign({}, state.stack),
}); };
exports.filterMapper = function (filterState) { return ({
    filter: __assign({}, filterState),
}); };
exports.notificationMapper = function (state) { return ({
    notification: __assign({}, state.notification),
}); };
exports.channelMapper = function (state) { return ({
    channel: __assign({}, state.channel),
}); };
exports.filterWrapperMapper = function (filterState) {
    return exports.filterMapper(filterState.filter);
};
/**
 * @stable [29.05.2018]
 * @param {IEditableEntity} editableEntity
 * @returns {IFilterActionConfiguration}
 */
exports.activeClassNameEditableEntityMapper = function (editableEntity) {
    return ({ className: editableEntity.dirty && 'rac-filter-active' });
};
/**
 * @stable [29.05.2018]
 * @param {IFilterFormWrapperEntity} filterFormWrapperEntity
 * @returns {IFilterActionConfiguration}
 */
exports.activeClassNameFilterFormWrapperEntityMapper = function (filterFormWrapperEntity) {
    return exports.activeClassNameEditableEntityMapper(filterFormWrapperEntity.filterForm);
};
/**
 * @stable [29.05.2018]
 * @param {IFilterFormWrapperEntity} filterFormWrapperEntity
 * @returns {IFilterActionConfiguration}
 */
exports.openFilterFilterFormWrapperEntityMapper = function (filterFormWrapperEntity) { return (__assign({ type: configurations_definitions_interface_1.ToolbarActionEnum.OPEN_FILTER }, exports.activeClassNameFilterFormWrapperEntityMapper(filterFormWrapperEntity))); };
/**
 * @stable [26.08.2018]
 * @param {IFilterFormWrapperEntity} filterFormWrapperEntity
 * @returns {IFilterActionConfiguration}
 */
exports.refreshWrapperEntityMapper = function (filterFormWrapperEntity) { return ({
    type: configurations_definitions_interface_1.ToolbarActionEnum.REFRESH_DATA,
}); };
// TODO
exports.refreshListAndFilterFormWrapperEntityMapper = function (mappedEntity, actions) { return (__assign({ actions: util_1.orDefault(util_1.isDef(mappedEntity.filterForm), function () { return [exports.openFilterFilterFormWrapperEntityMapper(mappedEntity)]; }, []).concat((actions || []).map(function (action) { return (__assign({ disabled: R.isNil(mappedEntity.list.data) || mappedEntity.list.progress }, action)); })), notUseField: true, icon: 'refresh' }, universal_connector_mapper_1.actionsDisabledListWrapperEntityMapper(mappedEntity))); };
/**
 * @stable [31.05.2018]
 * @param {IListAndFilterFormWrapperEntity} mappedEntity
 * @returns {IFilterConfiguration}
 */
exports.listAndFilterFormWrapperEntityMapper = function (mappedEntity) { return (__assign({ actions: [
        exports.refreshWrapperEntityMapper(mappedEntity),
        exports.openFilterFilterFormWrapperEntityMapper(mappedEntity)
    ] }, universal_connector_mapper_1.actionsDisabledListWrapperEntityMapper(mappedEntity))); };
exports.defaultMappers = universal_connector_mapper_1.universalDefaultMappers.concat([
    exports.stackMapper,
    exports.layoutMapper,
    exports.rootMapper,
    exports.notificationMapper,
    exports.channelMapper
]);
//# sourceMappingURL=connector.mapper.js.map