"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var dialog_component_1 = require("../dialog.component");
var form_1 = require("../../form");
var util_1 = require("../../../util");
var ArbitraryFormDialog = /** @class */ (function (_super) {
    __extends(ArbitraryFormDialog, _super);
    /**
     * @stable [03.08.2018]
     * @param {IArbitraryFormDialogProps} props
     */
    function ArbitraryFormDialog(props) {
        var _this = _super.call(this, props) || this;
        _this.onFormValid = _this.onFormValid.bind(_this);
        _this.onFormChange = _this.onFormChange.bind(_this);
        _this.state = { form: form_1.INITIAL_APPLICATION_FORM_STATE };
        return _this;
    }
    /**
     * @stable [03.08.2018]
     */
    ArbitraryFormDialog.prototype.activate = function (callback) {
        _super.prototype.activate.call(this, callback);
        this.setState({ form: form_1.INITIAL_APPLICATION_FORM_STATE }, callback);
    };
    /**
     * @stable [03.08.2018]
     */
    ArbitraryFormDialog.prototype.onAccept = function () {
        var props = this.props;
        if (props.onAccept) {
            props.onAccept(this.state.form.changes);
        }
    };
    /**
     * @stable [03.08.2018]
     * @returns {React.ReactNode}
     */
    ArbitraryFormDialog.prototype.getDialogBodyElement = function () {
        var props = this.props;
        return (React.createElement(form_1.Form, __assign({}, props.formConfiguration, { form: this.state.form, notUseActions: true, onChange: this.onFormChange }), _super.prototype.getDialogBodyElement.call(this)));
    };
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    ArbitraryFormDialog.prototype.isAcceptButtonDisabled = function () {
        return _super.prototype.isAcceptButtonDisabled.call(this) || !form_1.isFormSubmittable(this.state);
    };
    /**
     * @stable [03.08.2018]
     * @param {boolean} valid
     */
    ArbitraryFormDialog.prototype.onFormValid = function (valid) {
        this.setState({ form: this.buildNextFormState({ valid: valid }) });
    };
    /**
     * @stable [03.08.2018]
     * @param {IFieldChangeEntity} payload
     */
    ArbitraryFormDialog.prototype.onFormChange = function (payload) {
        this.setState({ form: this.buildNextFormState(payload) });
    };
    /**
     * @stable [03.08.2018]
     * @param {AnyT} payload
     * @returns {IEditableEntity}
     */
    ArbitraryFormDialog.prototype.buildNextFormState = function (payload) {
        // Redux State emulating
        return form_1.formReducer(this.state.form, {
            type: form_1.FormActionBuilder.buildChangeActionType(ArbitraryFormDialog.REDUCER_FORM_SECTION),
            data: __assign({ section: ArbitraryFormDialog.REDUCER_FORM_SECTION }, payload),
        });
    };
    ArbitraryFormDialog.REDUCER_FORM_SECTION = util_1.uuid();
    return ArbitraryFormDialog;
}(dialog_component_1.Dialog));
exports.ArbitraryFormDialog = ArbitraryFormDialog;
//# sourceMappingURL=arbitrary-form-dialog.component.js.map