"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue2Dropzone = require("vue2-dropzone");
var vue_property_decorator_1 = require("vue-property-decorator");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../../util");
var vue_index_1 = require("../connector/vue-index");
var vue_index_2 = require("../base/vue-index");
var vueDndLogger = ts_smart_logger_1.LoggerFactory.makeLogger('VueDnd');
var VueDnd = /** @class */ (function (_super) {
    __extends(VueDnd, _super);
    function VueDnd() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.id = util_1.uuid(true);
        return _this;
    }
    /**
     * @stable [25.11.2018]
     * @param {File[]} files
     */
    VueDnd.prototype.onDrop = function (files) {
        vueDndLogger.debug('[$VueDnd] The dropped files:', files);
        this.$emit('select', files);
    };
    /**
     * @stable [25.11.2018]
     * @returns {IKeyValue}
     */
    VueDnd.prototype.getOptions = function () {
        return __assign({}, this.$data.defaultOptions, this.options, { dictDefaultMessage: this.defaultMessage
                ? this.t(this.defaultMessage)
                : this.t(this.settings.messages.dndMessage) });
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueDnd.prototype, "options", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueDnd.prototype, "defaultMessage", void 0);
    VueDnd = __decorate([
        vue_index_1.ComponentName('vue-dnd'),
        vue_property_decorator_1.Component({
            components: {
                vue2Dropzone: vue2Dropzone,
            },
            data: function () { return ({
                defaultOptions: {
                    url: 'https://',
                    autoQueue: false,
                    previewTemplate: '<div class="rac-display-none"/>',
                },
            }); },
            template: "\n    <vue2Dropzone :id=\"id\"\n                  :options=\"getOptions()\"\n                  @vdropzone-files-added=\"onDrop\"/>\n  ",
        })
    ], VueDnd);
    return VueDnd;
}(vue_index_2.VueBaseComponent));
//# sourceMappingURL=vue-dnd.component.js.map