"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var R = require("ramda");
var util_1 = require("../../util");
var DomAccessor = /** @class */ (function () {
    function DomAccessor() {
    }
    /**
     * @stable [13.12.2018]
     * @param {Element} source
     * @returns {number}
     */
    DomAccessor.prototype.getHeight = function (source) {
        return util_1.getHeight(source);
    };
    /**
     * @stable [13.12.2018]
     * @param {Element} source
     * @returns {IJQueryElement}
     */
    DomAccessor.prototype.toJqEl = function (source) {
        return util_1.toJqEl(source);
    };
    /**
     * @stable [01.12.2018]
     * @param {Element} el
     * @returns {IXYEntity}
     */
    DomAccessor.prototype.getScrollInfo = function (el) {
        return { x: util_1.getScrollLeft(el), y: util_1.getScrollTop(el) };
    };
    /**
     * @stable [01.12.2018]
     * @param {Element} source
     * @returns {number}
     */
    DomAccessor.prototype.getContentHeight = function (source) {
        return util_1.getContentHeight(source);
    };
    /**
     * @stable [01.12.2018]
     * @param {Element} parent
     * @returns {Element}
     */
    DomAccessor.prototype.findUniversalSelectedElement = function (parent) {
        return util_1.findUniversalSelectedElement(parent);
    };
    /**
     * @stable [01.12.2018]
     * @param {IXYEntity | Element} payload
     * @param {Element} parent
     */
    DomAccessor.prototype.scrollTo = function (payload, parent) {
        if (R.isNil(payload)) {
            return;
        }
        var xyEntity = payload;
        var el = payload;
        if (el instanceof Element) {
            util_1.scrollIntoView(el, parent);
        }
        else if (!R.isNil(xyEntity.x) || !R.isNil(xyEntity.y)) {
            util_1.scrollTo(parent, xyEntity);
        }
    };
    /**
     * @stable [01.12.2018]
     * @param {Element} el
     * @param {number} top
     */
    DomAccessor.prototype.setScrollTop = function (el, top) {
        util_1.setScrollTop(el, top);
    };
    DomAccessor = __decorate([
        inversify_1.injectable()
    ], DomAccessor);
    return DomAccessor;
}());
exports.DomAccessor = DomAccessor;
//# sourceMappingURL=dom-accessor.service.js.map