/// <reference types="react" />
import { IJqInput } from '../../../util';
import { AnyT, IKeyboardEvent, IChangeEvent, IFocusEvent } from '../../../definitions.interface';
import { IField, IFieldInputProps, IFieldInternalProps, IFieldState, IFieldTextAreaProps } from './field.interface';
import { UniversalField } from './universal-field.component';
import { IBasicEvent } from '../../../react-definitions.interface';
export declare class Field<TComponent extends IField<TInternalProps, TState>, TInternalProps extends IFieldInternalProps, TState extends IFieldState = IFieldState> extends UniversalField<TComponent, TInternalProps, TState, IKeyboardEvent, IFocusEvent, IBasicEvent> implements IField<TInternalProps, TState> {
    onChangeManually(currentRawValue: AnyT, context?: AnyT): void;
    /**
     * @stable [18.06.2018]
     * @param {IChangeEvent} event
     * @returns {AnyT}
     */
    getRawValueFromEvent(event: IChangeEvent): AnyT;
    /**
     * @stable [17.06.2018]
     */
    resetError(): void;
    /**
     * @stable [03.09.2018]
     * @param {IKeyboardEvent} event
     */
    onKeyDown(event: IKeyboardEvent): void;
    /**
     * @stable [20.08.2018]
     */
    setFocus(): void;
    /**
     * @stable [05.10.2018]
     * @returns {HTMLInputElement | HTMLTextAreaElement}
     */
    readonly input: HTMLInputElement | HTMLTextAreaElement;
    /**
     * @stable [05.10.2018]
     * @returns {boolean}
     */
    protected readonly hasInput: boolean;
    /**
     * @stable [20.08.2018]
     */
    protected removeFocus(): void;
    /**
     * @stable [30.10.2018]
     * @param {IFocusEvent} event
     */
    protected onBlur(event: IFocusEvent): void;
    /**
     * @stable [30.10.2018]
     * @param {IFocusEvent} event
     */
    protected onFocus(event: IFocusEvent): void;
    /**
     * @stable [31.08.2018]
     * @returns {JSX.Element}
     */
    protected getInputElement(): JSX.Element;
    protected getInputElementProps(): IFieldInputProps | IFieldTextAreaProps;
    /**
     * @stable [18.06.2018]
     * @param {IBasicEvent} event
     */
    protected onClick(event: IBasicEvent): void;
    /**
     * @stable [06.10.2018]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [03.09.2018]
     * @returns {boolean}
     */
    protected hasInputFocus(): boolean;
    protected getInputElementWrapperClassName(): string;
    /**
     * stable [18.06.2018]
     * @example [
     *            rac-checkbox-field,
     *            rac-text-field
     *          ]
     * @stable
     * @returns Class name
     */
    protected getSelfElementClassName(): string;
    /**
     * @stable [31.07.2018]
     * @returns {boolean}
     */
    protected isInputValid(): boolean;
    /**
     * @stable [31.07.2018]
     * @returns {string}
     */
    protected getNativeInputValidationMessage(): string;
    /**
     * @stable [31.07.2018]
     * @param {string} error
     */
    protected setNativeInputValidity(error: string): void;
    /**
     * @stable [03.09.2018]
     * @param {string} message
     * @param {string} className
     * @returns {JSX.Element}
     */
    protected toMessageElement(message: string, className?: string): JSX.Element;
    /**
     * @stable [17.06.2018]
     * @param {AnyT} value
     */
    private updateInputBeforeHTML5Validation;
    /**
     * @stable [04.09.2018]
     * @returns {IJqInput}
     */
    protected readonly jqInput: IJqInput;
}
