"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var base_1 = require("../../base");
var util_1 = require("../../../util");
var definitions_interface_1 = require("../../../definitions.interface");
var GridRow = /** @class */ (function (_super) {
    __extends(GridRow, _super);
    /**
     * @stable - 05.04.2018
     * @param {IGridRowProps} props
     */
    function GridRow(props) {
        var _this = _super.call(this, props) || this;
        _this.onClick = _this.onClick.bind(_this);
        return _this;
    }
    /**
     * @stable - 05.04.2018
     * @returns {JSX.Element}
     */
    GridRow.prototype.render = function () {
        var props = this.props;
        return (React.createElement("tr", { ref: 'self', className: util_1.toClassName('rac-grid-row', props.selected && "rac-grid-row-selected " + definitions_interface_1.UNIVERSAL_SELECTED_ELEMENT_SELECTOR, props.className), onClick: this.onClick }, props.children));
    };
    /**
     * @stable - 05.04.2018
     * @param {IBasicEvent} event
     */
    GridRow.prototype.onClick = function (event) {
        var elClassList = event.target.classList;
        var props = this.props;
        if (!props.onClick) {
            return;
        }
        if (props.excludeTargetsClasses.find(function (cls) { return elClassList.contains(cls); })) {
            // We cannot call a stopEvent method because framework
            return;
        }
        props.onClick();
    };
    GridRow.defaultProps = {
        excludeTargetsClasses: ['rac-field-input'],
    };
    return GridRow;
}(base_1.BaseComponent));
exports.GridRow = GridRow;
//# sourceMappingURL=grid-row.component.js.map