/// <reference types="react" />
import { LayoutContainer } from '../layout.container';
import { IDefaultLayoutContainerProps } from './default-layout.interface';
export declare class DefaultLayoutContainer extends LayoutContainer<IDefaultLayoutContainerProps> {
    static defaultProps: IDefaultLayoutContainerProps;
    private readonly PROFILE_EXIT_ACTION;
    private readonly USER_MENU_OPTIONS;
    private userMenuRef;
    private navigationMenuBuilder;
    /**
     * @stable [18.09.2018]
     * @param {IDefaultLayoutContainerProps} props
     */
    constructor(props: IDefaultLayoutContainerProps);
    /**
     * @stable [18.09.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [18.09.2018]
     * @param {IBasicEvent} event
     */
    private onUserMenuActionClick;
    /**
     * @stable [18.09.2018]
     * @param {IMenuItemEntity} menuItem
     */
    private onUserMenuSelect;
    /**
     * @stable [18.09.2018]
     * @param {IStringMenuActionEntity} option
     */
    private onHeaderMoreOptionsSelect;
    /**
     * @stable [17.10.2018]
     */
    private onLogoMenuActionClick;
    /**
     * @stable [18.09.2018]
     */
    private onHeaderNavigationActionClick;
    /**
     * @stable [01.12.2018]
     * @param {IXYEntity} xy
     */
    private onNavigationListScroll;
    /**
     * @stable [23.09.2018]
     * @param {INavigationListItemConfiguration} item
     */
    private onNavigationListGroupClick;
    /**
     * @stable [23.09.2018]
     * @returns {boolean}
     */
    private readonly layoutFullModeEnabled;
    /**
     * @stable [23.09.2018]
     * @returns {LayoutModeEnum}
     */
    private readonly layoutMode;
    /**
     * @stable [18.09.2018]
     * @returns {INavigationListItemConfiguration[]}
     */
    private readonly menuItems;
    /**
     * @stable [18.09.2018]
     * @returns {JSX.Element}
     */
    private readonly headerElement;
    /**
     * @stable [18.09.2018]
     * @returns {JSX.Element}
     */
    private readonly drawerElement;
    /**
     * @stable [17.10.2018]
     * @param {IBasicEvent} event
     */
    private onProfileMenuClick;
    /**
     * @stable [08.10.2018]
     * @returns {JSX.Element}
     */
    private readonly mainElement;
    /**
     * @stable [08.10.2018]
     * @returns {JSX.Element}
     */
    private readonly footerElement;
    /**
     * @stable [18.09.2018]
     * @returns {JSX.Element}
     */
    private readonly mainProgressOverlayElement;
    /**
     * @stable [18.09.2018]
     * @returns {JSX.Element}
     */
    private readonly userMenuElement;
}
