import * as React from 'react';
import { UniversalComponent } from '../base/universal.component';
import { IUniversalMessageProps } from './universal-message.interface';
export declare abstract class UniversalMessage<TComponent extends UniversalMessage<TComponent, TProps, TState>, TProps extends IUniversalMessageProps = IUniversalMessageProps, TState = {}> extends UniversalComponent<TComponent, TProps, TState> {
    /**
     * @stable [23.04.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [23.04.2018]
     * @returns {string | JSX.Element}
     */
    protected abstract getProgressLabel(): string | JSX.Element;
    /**
     * @stable [09.06.2018]
     * @param {React.ReactNode} message
     * @param {React.ReactNode} node
     * @returns {JSX.Element}
     */
    protected abstract getMessageWrapper(message: React.ReactNode, node: React.ReactNode): JSX.Element;
    /**
     * @stable [17.08.2018]
     * @returns {string}
     */
    private getErrorMessage;
    /**
     * @stable [09.06.2018]
     * @returns {React.ReactNode}
     */
    private getEmptyMessage;
    /**
     * @stable [23.04.2018]
     * @returns {string}
     */
    private getEmptyDataMessage;
}
