"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var util_1 = require("../util");
/**
 * @stable [14.06.2018]
 * @param {T} o
 * @returns {T}
 */
exports.shallowCloneIfExists = function (o) { return util_1.orNull(!R.isNil(o), function () { return (__assign({}, o)); }); };
/**
 * @stable [14.06.2018]
 * @param {T} o
 * @returns {T}
 */
exports.clone = function (o) { return R.clone(o); };
function cloneNodes(component, mergedProps, mergePropsPredicate, childrenMap, renderPredicate) {
    return React.Children.map(component.props.children, function (child) {
        if (R.isNil(child)) {
            return null;
        }
        else if (util_1.isPrimitive(child)) {
            return child;
        }
        else {
            var reactChild = child;
            var uuidRef = util_1.uuid();
            var canMergeProps = mergePropsPredicate(reactChild);
            var canRender = renderPredicate ? renderPredicate(reactChild) : true;
            if (!R.isNil(canRender) && !canRender) {
                return null;
            }
            var clonedChild = React.cloneElement(reactChild, __assign({}, (canMergeProps
                ? __assign({ ref: uuidRef }, (util_1.isFn(mergedProps)
                    ? mergedProps(reactChild)
                    : mergedProps)) : {}), { children: cloneNodes(reactChild, mergedProps, mergePropsPredicate, childrenMap, renderPredicate) }));
            if (childrenMap && canMergeProps) {
                childrenMap.set(clonedChild, uuidRef);
            }
            return clonedChild;
        }
    });
}
exports.cloneNodes = cloneNodes;
//# sourceMappingURL=clone.js.map