"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var util_1 = require("../util");
var definitions_interface_1 = require("../definitions.interface");
/**
 * @stable [09.05.2018]
 * @param {IPaginatedEntity} entity
 * @returns {number}
 */
exports.pageFromNumber = function (entity) {
    return 1 + (entity.page - definitions_interface_1.FIRST_PAGE) * entity.pageSize;
};
/**
 * @stable [29.05.2018]
 * @param {IPaginatedEntity} entity
 * @returns {number}
 */
exports.pageToNumber = function (entity) {
    return util_1.orNull(!R.isNil(entity.pageSize), function () { return Math.min(entity.page * entity.pageSize, entity.totalCount); });
};
//# sourceMappingURL=page.js.map